const { 
  api_chance_num,
  api_get_qrcode
 } = require('../../utils/api.js');
const { net } = require('../../utils/net.js');
const util = require('../../utils/util.js');
import Poster from '../../utils/poster.js'


Page({
  data: {
    showState: '1',
    userInfo: {},
    cardsArr: [{
      id: '1',
      icon: '../../imgs/icon1.png',
      title: '新增线索',
      etitle:'Register'
    }, {
      id: '2',
      icon: '../../imgs/icon2.png',
      title: '线索管理',
      etitle:'Manage'
    }, {
      id: '3',
      icon: '../../imgs/icon3.png',
      title: '意向收集',
      etitle:'Questionnaire'
    }, {
      id: '4',
      icon: '../../imgs/icon4.png',
      title: '渠道拓展',
      etitle:'Invitation'
    }],
    pickerIndex:2,
    list:[
      '上周','本周','上月','本月','全部'
    ],
    data:null,
    showMask: false,
    isShowPostMask:false,
    isShowCanvas: false,
    collectbarcodeImgUrl: 'https://discuz.hoolihome.com/defaults/barcode2.jpg',
    extendBarcodeImgUrl: 'https://discuz.hoolihome.com/defaults/barcode2.jpg',
    isShowCollectPoster:false,
    isShowExtendPoster:false,
    collectPosterImgSrc: '',
    extendPosterImgSrc:'',
    collectPosterArr:null,
    extendPosterArr:null,
    template: null,
    itemId:null,
    feedback:{
      img:'https://static.hoolihome.com/weapp/distributor/collection.png?x-oss-process=image/resize,w_320',
      title:'租房意向收集表'
    },
    extendObj:null,
    postImgSrc:null
  },
  onLoad: function (options) {
    let userInfo = util.getStorageSync('userInfo');
    if (userInfo) {
      this.data.feedback.headImg = userInfo.avatar || 'https://static.hoolihome.com/weapp/distributor/logo.png'
      this.setData({
        showState: '2',
        userInfo:userInfo,
        feedback:this.data.feedback
      });
      this.getWithData();
      this.getBarcode();
      this.getBarcode(1);
      this.judgeWithUser(userInfo);
    } else {
      wx.reLaunch({
        url: '/pages/loginways/loginways',
      });
    }
  },
  onReady: function () {
    wx.setNavigationBarTitle({
      title: 'Hooli Partner'
    });
  },
  judgeWithUser(userInfo) {
    let { userType, avatar, nickName } = userInfo;
    userType = userType.toString();
    this.getBarcode(userType);
    let extendObj = null;
    if (userType === '1') {
      extendObj = {
        title: `${nickName}邀请你成为hooli分销商`,
        img: 'https://static.hoolihome.com/weapp/distributor/invite.png?x-oss-process=image/resize,w_320',
        headImg:avatar
      }
    } else if (userType === '2') {
      extendObj = {
        title: `${nickName}邀请你成为hooli顾问`,
        img: 'https://static.hoolihome.com/weapp/distributor/invite.png?x-oss-process=image/resize,w_320',
        headImg:avatar
      }
    }

    this.setData({
      extendObj:extendObj
    });
  },
  getWithData() {
    let _this = this
    let params = {
      url: api_chance_num,
      data: {
        type: this.data.pickerIndex + 1
      }
    }
    net.req(params).then((res) => {
      _this.setData({
        data:res.data
      })
    })
  },
  bindPickerChange(e) {
    if (parseInt(e.detail.value)!= this.data.pickerIndex) {
      this.setData({
        pickerIndex: parseInt(e.detail.value)
      });
      this.getWithData();
    }
    
  },
  handleItemTap(e) {
    let { currentId } = e.currentTarget.dataset;
    const _this = this;
    switch (currentId) {
      case '1':
        wx.navigateTo({
          url: '/pages/customadd/customadd',
        })
        break;
      case '2':
        wx.navigateTo({
          url: '/pages/leadslist/leadslist',
        })
        break;
      default:
        wx.hideTabBar({
          complete:function() {
            _this.setData({
              itemId:currentId,
              showMask:true
            });
          }
        });
        break;
    }
  },
  onShareAppMessage(e) {
    let { userInfo } = this.data;
    
    //判断是否点击小程序自带转发
    let { itemId } = e.from == 'menu' ? {} : e.target.dataset ;
    
    if (itemId && itemId === '3') {
      return {
        title: '租房意向收集表',
        imageUrl: 'https://static.hoolihome.com/weapp/distributor/collection.png?x-oss-process=image/resize,w_320',
        path: `/pages/leadscollection/leadscollection?shareToken=${userInfo.shareToken}`,
        success: (res) => {
        }
      }
    } else {
      let { userType, shareToken, nickName } = userInfo;
      userType = userType.toString();
      if (userType === '1') {
        return {
          title: `${nickName}邀请你成为hooli分销商`,
          imageUrl: 'https://static.hoolihome.com/weapp/distributor/invite.png?x-oss-process=image/resize,w_320',
          path: `/pages/registerdistributor/registerdistributor?shareToken=${shareToken}`,
          success: (res) => {
          }
        }
      } else if (userType === '2') {
        return {
          title: `${nickName}邀请你成为hooli顾问`,
          imageUrl: 'https://static.hoolihome.com/weapp/distributor/invite.png?x-oss-process=image/resize,w_320',
          path: `/pages/registeradviser/registeradviser?shareToken=${shareToken}`,
          success: (res) => {
            wx.showToast({
              title: '分享成功',
              icon: 'none'
            })
          }
        }
      } 
    }
  },
  getBarcode: function(type) {
    let { userInfo } = this.data;
    let {userType, shareToken } = userInfo;

    let params = {},page = 'pages/leadscollection/leadscollection';
    params.url = api_get_qrcode;

    if (type) {
      page = userType === '2' ? 'pages/registeradviser/registeradviser' : 'pages/registerdistributor/registerdistributor'
    }
    params.data = {
      scene: shareToken,
      page: page,
      width: 150,
      contentType: 'distributorWX',
      t: 'wap'
    };
    net.req(params).then((res) => {
      let barcodeImgUrl = res.data.host + res.data.url;
      if (type) {
        this.setData({
          extendBarcodeImgUrl:barcodeImgUrl,
          isShowExtendPoster: true
        });
      } else {
        this.setData({
          collectBarcodeImgUrl:barcodeImgUrl,
          isShowCollectPoster: true
        });
      }
    });
  },
  posterCallack: function(arr,type) {
    arr.forEach((v, i, a) => {
      let {
        elementId,
        dataset
      } = v;
      if (elementId.indexOf('img') !== -1) {
        wx.getImageInfo({
          src: dataset.what,
          success: (res) => {
            v.dataset.uri = res.path;
          }
        });
      }
    });

    if (type === 'collect'){
      this.setData({
        isShowCollectPoster: false,
        collectPosterArr: arr
      });
    } else {
      this.setData({
        isShowExtendPoster: false,
        extendPosterArr: arr
      });
    }
    
  },
  maskHide: function() {
    this.setData({
      showMask: false,
    },() => {
      wx.showTabBar()
    });
    
    
  },
  handleGeneratePoster: function(e) {
    let posterArr = null;
    const _this = this;
    if (this.data.itemId === '3') {
      posterArr = this.data.collectPosterArr;
      if (this.data.collectPosterImgSrc) {
        _this.setData({
          showMask: false,
        }, () => {
          wx.showTabBar();
          let {
            collectPosterImgSrc
          } = _this.data;
          _this.setData({
            isShowPostMask:true,
            postImgSrc:collectPosterImgSrc
          })
        });
        return;
      } 
    } else {
      posterArr = this.data.extendPosterArr;
      if (this.data.extendPosterImgSrc) {
          _this.setData({
            showMask: false,
          }, () => {
            wx.showTabBar();
            let {
              extendPosterImgSrc
            } = _this.data;
            _this.setData({
              isShowPostMask:true,
              postImgSrc:extendPosterImgSrc
            })
          });
        return;
      } 
    }
    
    _this.setData({
      showMask: false,
      isShowCanvas: true
    }, () => {
      wx.showTabBar();
      let palette = new Poster().palette(posterArr);
      _this.setData({
        template: palette
      });
      wx.showLoading({
        title: '生成海报中...'
      });
    });
  },
  onImgOK(e) {
    const {itemId} = e.currentTarget.dataset;
    const canvasSrc = e.detail.path;
    wx.hideLoading();
    this.setData({
      isShowCanvas: false
    }, () => {
      if (itemId === '3') {
          this.data.collectPosterImgSrc = canvasSrc;
      } else {
        this.data.extendPosterImgSrc = canvasSrc;
      }
      this.setData({
        isShowPostMask:true,
        postImgSrc:canvasSrc
      })
    });
  },
  postMaskHide() {
    this.setData({
      isShowPostMask:false
    })
  },
  saveImgAction(e) {
    const {itemId} = e.currentTarget.dataset;
    const _this = this;
    let filePath = null;
    if (itemId === '3') {
      filePath = this.data.collectPosterImgSrc;
    } else {
      filePath = this.data.extendPosterImgSrc;
    }
    wx.saveImageToPhotosAlbum({
      filePath:filePath,
      success(res) {
        wx.showToast({
          title: '保存成功',
          icon: 'none',
          duration: 1000
        });
        _this.setData({
          isShowPostMask:false
        })
      },
      fail(){
        wx.showModal({
          title: '授权失败',
          content: '是否打开小程序设置界面，完成对该小程序授权状态',
          success: function(res) {
            if (res.confirm) {
              wx.openSetting({
                success(res) {}
              })
            } 
          }
        })
      }
    })
  },
  // 用于阻断事件传递
  interdictEventsAction() {

  }
})